package com.persagy.proxy.adm.service;

import com.persagy.proxy.adm.model.AdmBuilding;
import com.persagy.proxy.adm.model.AdmDCSQueryRequest;
import com.persagy.proxy.adm.model.AdmSpace;
import com.persagy.proxy.adm.model.AdmUpDataFloorAndBuildingRequests;
import com.persagy.proxy.adm.request.AdmQueryCriteria;
import com.persagy.proxy.adm.request.AdmResponse;
import com.persagy.proxy.common.entity.InstanceUrlParam;
import org.apache.poi.ss.formula.functions.T;

import java.util.List;

/**
 * ADM 空间 接口
 * @author lvxy
 * @date 2021/8/18
 */
public interface IAdmSpaceService extends IAdmBaseService<AdmSpace>{

    /**
     * 新增
     * @param context
     * @param clazz
     * @param voList
     * @return
     */
    List<AdmSpace> doInsertExt(InstanceUrlParam context, Class<AdmSpace> clazz, List<AdmSpace> voList);

    /**
     * 修改
     * @param context
     * @param clazz
     * @param voList
     * @return
     */
    List<AdmSpace> doUpdateExt(InstanceUrlParam context, Class<AdmSpace> clazz, List<AdmSpace> voList);

    /**
     * 修改空间对象的楼层建筑信息
     * @param context
     * @param voList
     * @return
     */
    List<AdmSpace> doUpdateFloorORBuilding(InstanceUrlParam context, List<AdmUpDataFloorAndBuildingRequests> voList);

    /**
     * 修改空间轮廓线
     * @param context
     * @param clazz
     * @param voList
     * @return
     */
    List<AdmSpace> doUpdateOutline(InstanceUrlParam context, Class<AdmSpace> clazz, List<AdmSpace> voList);


    /**
     * 删除
     *
     * @param context
     * @param voList
     * @return
     */
    void doDeleteExt(InstanceUrlParam context, List<AdmSpace> voList);

    /**
     * 查询业务空间所有类型
     */
    AdmResponse doQueryType(InstanceUrlParam context, AdmDCSQueryRequest request);


    /**
     * 查询业务空间
     */
    AdmResponse doQuerySpaces(InstanceUrlParam context, AdmQueryCriteria request, Class<AdmSpace> clazz);
}
